# Upsert module lifecycle rule

Create or replace the lifecycle rule for a module, atomically replacing all overrides

Endpoint: PUT /iacm/api/modules/{id}/lifecycle
Version: 1.0
Security: x-api-key

## Query parameters:

  - `scope_org` (string)
    Org scope of the module
    Example: "Dolor qui."

  - `scope_project` (string)
    Project scope of the module
    Example: "Vero esse quia error."

## Path parameters:

  - `id` (string, required)
    Module ID
    Example: "Odit voluptate corporis libero."

## Header parameters:

  - `Harness-Account` (string, required)
    Account name
    Example: "Atque quae officia et accusantium ut voluptas."

## Request fields (application/json):

  - `deprecated_action` (string, required)
    Enforcement action for deprecated-tier versions
    Enum: "no_action", "warn", "fail"

  - `overrides` (array)
    Manual per-version tier overrides
    Example: [{"tier":"warning","version":"v2.1.0"},{"tier":"warning","version":"v2.1.0"},{"tier":"warning","version":"v2.1.0"}]

  - `overrides.tier` (string, required)
    Lifecycle tier to assign to this version
    Enum: "supported", "warning", "deprecated"

  - `overrides.version` (string, required)
    Version string to override
    Example: "v2.1.0"

  - `supported_action` (string, required)
    Enforcement action for supported-tier versions
    Enum: "no_action", "warn", "fail"

  - `supported_count` (integer, required)
    Number of most-recent non-pre-release versions classified as supported
    Example: 3

  - `warning_action` (string, required)
    Enforcement action for warning-tier versions
    Enum: "no_action", "warn", "fail"

  - `warning_count` (integer, required)
    Number of versions immediately after the supported window classified as warning
    Example: 2

## Response 200 fields (application/json):

  - `deprecated_action` (string, required)
    Enforcement action for deprecated-tier versions
    Enum: "no_action", "warn", "fail"

  - `overrides` (array)
    Manual per-version tier overrides
    Example: [{"tier":"supported","version":"v2.1.0"},{"tier":"supported","version":"v2.1.0"},{"tier":"supported","version":"v2.1.0"}]

  - `supported_action` (string, required)
    Enforcement action for supported-tier versions
    Enum: "no_action", "warn", "fail"

  - `supported_count` (integer, required)
    Number of most-recent non-pre-release versions classified as supported
    Example: 5436811384037271000

  - `warning_action` (string, required)
    Enforcement action for warning-tier versions
    Enum: "no_action", "warn", "fail"

  - `warning_count` (integer, required)
    Number of versions immediately after the supported window classified as warning
    Example: 7771473456457534000

## Response 400 fields (application/vnd.goa.error):

  - `fault` (boolean, required)
    Is the error a server-side fault?
    Example: true

  - `id` (string, required)
    ID is a unique identifier for this particular occurrence of the problem.
    Example: "123abc"

  - `message` (string, required)
    Message is a human-readable explanation specific to this occurrence of the problem.
    Example: "parameter 'p' must be an integer"

  - `name` (string, required)
    Name is the name of this class of errors.
    Example: "bad_request"

  - `temporary` (boolean, required)
    Is the error temporary?
    Example: true

  - `timeout` (boolean, required)
    Is the error a timeout?


